

New Questions: Can port be shared ?

From: Kim Dong Ho

When two hosts, client C and server S, make connection each other. 
In this situation, a new host H want to communicate with client C through the port - ex, port 1000
- which is assigned 
to communicate with server S. 
Of course, there is no connection with client C and new host H. 
Can the new host H send packet to the client's opened port, port 1000. 
And, Can the client receive the packet from new host H through the port, port 1000, which is
opened to 
server S. 

Thanks for reading 

From: Vic Metcalfe

Lets look at a specific real life example. Lets say that joe@hostA.net and jane@hostB.net send
email to one another at the same time. Here's what happens... 

   Joe's email client sends his message to his smtp server which happens to be mail.hostA.net. 
      Jane's email client sends her message to her smtp server which happens to be mail.hostB.net. 
         The SMTP server at mail.hostA.net does an MX lookup on hostB.net which returns
	    mail.hostB.net 
	       The SMTP server at mail.hostB.net does an MX lookup on hostA.net which returns
	          mail.hostA.net 
		     The SMTP server at mail.hostA.net connects to port 25 of mail.hostB.net 
		        The SMTP server at mail.hostB.net connects to port 25 of mail.hostA.net 
			   The SMTP server at mail.hostA.net sends Joe's email to Jane at mail.hostB.net 
			      The SMTP server at mail.hostB.net sends Jane's email to Joe at mail.hostA.net
			      
			      You'll notice that mail.hostA.net connects to mail.hostB.net on port 25 at the same time that
			      mail.hostB.net connects to mail.hostA.net on the same port! The reason is that connections are
			      identified by five things: The source IP, the destination IP, the source port, the target port and the
			      IP protocol. The connections look like this: 
			      
			        Source IP
				             Dest IP
					                          Source Port
								                                Dest Port
												                                     IP Protocol
																      mail.hostA.net
																                 mail.hostB.net
																		                      25
																				                                    55851
																								                                         TCP
																													  mail.hostB.net
																													             mail.hostA.net
																														                          25
																																	                                55840
																																					                                     TCP
																																									     
																																									     
																																									     Each connection is unique, and there is no conflict. Otherwise mail servers wouldn't be able to
																																									     communicate with one another at the same time, you couldn't run a web browser from a web
																																									     server, etc. 
																																									     
																																									     I hope this helps,
																																									       Vic.
																																									       
																																									       From: Jay
																																									       
																																									       Hi, 
																																									          It cant be possible because when u sent mesg u will connect and connect will fail bcoz connect
																																										  intern call bind and u cant bind single port to two sockets. 
																																										  
																																										  From: caspre
																																										  
																																										  Jay: You're right that you can't bind two sockets to the same port, but when you accept a
																																										  connection from a listening socket on a port using accept(), a new socket is created on the same
																																										  port. This means that you now have the listening socket, and a new socket, both on the same port 
																																										  
																																										  From: Arthur Lung
																																										  
																																										  Two servers running on the same computer can't listen on the 
																																										  same port for connections. Like if you had two web servers, 
																																										  they couldn't both use port 80. When you try to start the 
																																										  second server, it notices the port is already in use and 
																																										  you get a big fat error. 
																																										  
																																										  On the other hand, two clients running on the same computer 
																																										  can connect to the same server and the same port simultaneously. 
																																										  The reason for that is because the "local port" that represents 
																																										  the client side endpoint of the communication is different for 
																																										  both clients. 
																																										  
																																										  So to summarize: 
																																										  
																																										  2 telnet servers on server Bob listening on port 23 = no way 
																																										  2 telnet connections to server bob connected to port 23 = happy land 
																																										  
																																										  From: Tim Jones
																																										  
																																										  Actually, Arthur, that's not exactly it either. If your computer has MORE than one IP address, you
																																										  can configure your server processes to listen to a particular IP and PORT combination. I have a
																																										  colocated Linux box with IPs x.y.z.7 and x.y.z.8. Apache listens to x.y.z.7:80 and Tomcat (another
																																										  webserver) listens to x.y.z.8:80. 
																																										  
																																										  You can also configure stuff to only listen to 127.0.0.1, which is a common way to secure stuff from
																																										  the outside world without turning it off completely.
																																										  
																																										  From: Tom
																																										  
																																										  If UDP is ok... Then you have no problem. Further if multicast is ok, then you can have many
																																										  applications all bound to the same port on the same machine with no problem. 
																																										  
																																										  From: Jay Lorenzo
																																										  
																																										  Just to clarify here, you can't bind to the port twice. For the SMTP example given, what happens is
																																										  that the initial connection is sent to port 25, but the accept function creates a socket on a totally
																																										  random port, and communication continues between the client and server on that port. When you
																																										  accept a connection, you are creating a new socket on an unpriveledged port. 
																																										  
																																										  From: Rob Seace
																																										  
																																										  Untrue... When you accept(), your local port is exactly the 
																																										  same as your listening port... It creates a new socket FD, 
																																										  yes; but, the local port remains unchanged... The reason it 
																																										  works is because the REMOTE IP and port differs; a TCP 
																																										  connection is uniquely identified by all 4 pieces of address 
																																										  info: source IP, source port, destination IP, destination 
																																										  port... The reason you can't bind() multiple servers to the 
																																										  local port for listening is because then, essentially, all 
																																										  4 of those would be the same, since the dest addr is unset 
																																										  in both cases... (Assuming you both bind() to the same 
																																										  local IP, as well... If you use a different one, all is 
																																										  fine, too...) 
																																										  
																																										  From: Anup
																																										  
																																										  Jay u r right. 
																																										  In TCP/IP, the client-server has a one to one communication through sockets. 
																																										  Here in this case, H cannot connect to C as the connect call fails. On the other side, if C has to
																																										  listen for H, it cannot bind on the same port, so the bind call fails. 
																																										  In this way, the data transfer between H and C wont be possible. 
																																										  
																																										  From: Anup Ray
																																										  
																																										  Jay u r right. 
																																										  In TCP/IP, the client-server has a one to one communication through sockets. 
																																										  Here in this case, H cannot connect to C as the connect call fails. On the other side, if C has to
																																										  listen for H, it cannot bind on the same port, so the bind call fails. 
																																										  In this way, the data transfer between H and C wont be possible. 
																																										  
																																										  From: Rob Seace
																																										  
																																										  I would agree that in the given original question, it 
																																										  doesn't seem likely to be able to do what is wanted... 
																																										  However, Jay is NOT right about accept() giving you a 
																																										  new ephemeral port#... Your local port# will be exactly 
																																										  the same for all accept()'d sockets (and, the same as 
																																										  the listening socket)... 
																																										  
																																										  From: Brian
																																										  
																																										  I dunno Rob. I admit I'm not a total pro on all this, and I'm only here looking for help on my own
																																										  problem, but when you do an accept() call, you pass it a "sockaddr" struct as a result parameter.
																																										  The accept call fills that struct with all sorts of information about the connection it makes, and if
																																										  you pull out the "sin_port" field of that struct, it will indicate a different port than the one that you
																																										  were listening on. 
																																										  
																																										  All my experience and education indicate that Jay is right. 
																																										  
																																										  From: Rob Seace
																																										  
																																										  No, no, no... The sockaddr passed to and filled in by 
																																										  accept() is the address of the REMOTE peer... Ie: the 
																																										  person on the other end of the connection... Not YOUR 
																																										  end of the connection... To get YOUR end of that same 
																																										  connection, do a getsockname()... And, you'll see that 
																																										  I'm quite correct... Or, simply type "netstat -a" while 
																																										  you've got a connection in progress, and note that the 
																																										  local port for both the LISTEN and ESTABLISHED connections 
																																										  are exactly the same... Trust me, I've been writing 
																																										  sockets code for many, many years; I know WTF I'm talking 
																																										  about... But, you can easily see for yourself, too... 
																																										  
																																										  From: Michael Lampkin
																																										  
																																										  First comment is... that this thread deals with connected sockets only. We can drift off into
																																										  discussions about unconnected UDP etc. communication but lets start another thread if that is
																																										  desired since it is out of the scope of the discussion. 
																																										  
																																										  Second comment is... and I am trying to be as polite as possible here... Please do NOT give
																																										  "authoritative" answers if you are not certain about the answer i.e. do not post until you have
																																										  TRIED and can SHOW it with code. I swear that at least 1/3 of my posts (which aren't that many
																																										  admittedly) are correcting such "authoritative" answers and explaining (in my own painfully verbose
																																										  manner) or showing why they are incorrect. That does not mean to not post if you are not 100%
																																										  certain about the answer to a particular question - this section of the faq is about us helping each
																																										  other - If you have comments that might help a person solve their problem, then offer then but if
																																										  you are not certain qualify them properly (that is, "I tested this on platform X with such and such
																																										  code and this was what I found", or "I think I saw this behaviour..." or... Well, you get the idea... 
																																										  
																																										  Third comment(s)... 
																																										  
																																										  Vic's original answer / example IS correct... Unfortunately, the assumption by some of the folks
																																										  posting (I guess) is that Vic left some steps out of the sequence... In particular is the assumption
																																										  that if you have a server bound to a specific port, that the server does initially accept the connection
																																										  on that port but then the call to accept assigns the new connection an unused empheral port on the
																																										  server... That assumption is incorrect! As Vic pointed out and Rob re-iterated (I especially liked the
																																										  big WTF part ;-), a connection's validity is based on the uniqueness of the COMPLETE address
																																										  (server address & port, client address & port)... There is NO NEED for accept to assign a new port
																																										  number on the local side for each incoming connection! 
																																										  
																																										  Fourth comment... 
																																										  
																																										  The next post is going to be some really crappy example server code... Change the ADDR & PORT
																																										  defines to valid values... Compile it... run it... Open some new windows on the same (or another for
																																										  that matter) machine and use telnet to make multiple connections to the server... You will notice
																																										  that even though the code is getting the local address / port information using the newly created file
																																										  descriptor(s), that the same server address & port is shown each and every time... In fact, if you are
																																										  using telnet on the same machine you are running the server on and only have 1 interface, you will
																																										  notice that the ONLY thing which changes is the client port number (because that IS "randomly"
																																										  assigned during the connect unless the client socket is previously bound "by hand" - which it isn't
																																										  with a normal telnet client)... 
																																										  
																																										  Hope this helps clear things up... 
																																										  
																																										  Now lets all have a group hug... ;-) 
																																										  
																																										  ML 
																																										  
																																										  From: Michael Lampkin
																																										  
																																										  /* 
																																										   * Silly little (and badly written) example programming showing that a 
																																										    * server accepting connections DOES receive and communicate with clients 
																																										     * using the same port for multiple connections and that connection is 
																																										      * determined unique by the full address sequence. 
																																										       * 
																																										        * That is... server addr : server port : remote addr : remote port 
																																											 * 
																																											  * Example ONLY. Use at your own risk! etc. etc. etc. 
																																											   * 
																																											    * Michael Lampkin 
																																											     */ 
																																											     
																																											     
																																											     
																																											     #include <errno.h> 
																																											     #include <fcntl.h> 
																																											     #include <stdio.h> 
																																											     #include <unistd.h> 
																																											     
																																											     #include <arpa/inet.h> 
																																											     
																																											     #include <netinet/in.h> 
																																											     #include <netinet/tcp.h> 
																																											     
																																											     #include <sys/types.h> 
																																											     #include <sys/socket.h> 
																																											     
																																											     
																																											     
																																											     #define ADDR "192.168.1.50" 
																																											     #define PORT 7777 
																																											     
																																											     
																																											     
																																											     
																																											     
																																											     int main(int argc, char ** argv) 
																																											     { 
																																											     int serverDescriptor; 
																																											     int clientDescriptor; 
																																											     
																																											     struct sockaddr_in serverAddress; 
																																											     struct sockaddr_in clientAddress; 
																																											     
																																											     socklen_t lengthPtr; 
																																											     
																																											     
																																											     /* Create a new network stream type socket. */ 
																																											     
																																											             serverDescriptor = socket(AF_INET, SOCK_STREAM, 0); 
																																												     
																																												     if (serverDescriptor <= 0) 
																																												     { 
																																												     perror("Socket create : "); 
																																												     return 0; 
																																												     } 
																																												     
																																												     
																																												     /* Set our server address and port */ 
																																												     
																																												     memset(& serverAddress, sizeof(serverAddress), 0); 
																																												     
																																												     serverAddress.sin_addr.s_addr = inet_addr(ADDR); 
																																												     serverAddress.sin_port = htons(PORT); 
																																												     serverAddress.sin_family = AF_INET; 
																																												     
																																												     
																																												     /* Bind our server socket using previously defined information */ 
																																												     
																																												     if (bind(serverDescriptor, (struct sockaddr *) & serverAddress, sizeof(struct sockaddr)) == -1) 
																																												     { 
																																												     perror("Bind : "); 
																																												     return 0; 
																																												     } 
																																												     
																																												     
																																												     /* Set our socket to receive incoming connections with a max backlog of 50 pending. */ 
																																												     
																																												     if (listen(serverDescriptor, 50) == -1) 
																																												     { 
																																												     perror("Listen : "); 
																																												     return 0; 
																																												     } 
																																												     
																																												     
																																												     
																																												     /* Loop accepting connections - not we just drop accepted connection descriptors 
																																												     * for the demonstration and THIS will eventually consume all descriptors available 
																																												     * on the system and cause a freeze / crash - This is ONLY a demo to show that 
																																												     * the server port remains the same even when there are n simultaneous client connections 
																																												     * and I did not want to clutter the code with fork( ) calls etc. The descriptors 
																																												     * will be freed by the system when the process is killed. 
																																												     */ 
																																												     
																																												     while (1) 
																																												     { 
																																												     /* Accept an incoming connection */ 
																																												     
																																												     lengthPtr = sizeof(clientAddress); 
																																												     
																																												     clientDescriptor = accept(serverDescriptor, (struct sockaddr *) & clientAddress, & lengthPtr); 
																																												     
																																												     /* Make certain we have a valid incoming connection, if not 
																																												     * just break out at this time. 
																																												     */ 
																																												     
																																												     if (clientDescriptor == -1) 
																																												     { 
																																												     perror("Accept : "); 
																																												     return 0; 
																																												     } 
																																												     
																																												     
																																												     /* Get the LOCAL information for the currently connected client. Note that we ARE 
																																												     * USING THE NEWLY ACCEPTED DECRIPTOR to get this information!!!!!! 
																																												     */ 
																																												     
																																												     lengthPtr = sizeof(struct sockaddr); 
																																												     
																																												     if (getsockname(clientDescriptor , (struct sockaddr *) & serverAddress, & lengthPtr) == -1) 
																																												     { 
																																												     perror("Error getting server address : "); 
																																												     return 0; 
																																												     } 
																																												     
																																												     /* Obviously, output the address / port information to the console. */ 
																																												     
																																												     printf("Local Address : %s Local Port : %i --- Remote Address : %s Remote Port : %i\n", 
																																												     inet_ntoa(serverAddress.sin_addr), 
																																												                             ntohs(serverAddress.sin_port), 
																																															                             inet_ntoa(clientAddress.sin_addr), 
																																																		                             ntohs(clientAddress.sin_port)); 
																																																					     } 
																																																					     
																																																					     } 
																																																					     
																																																					     
																																																					     