#include <stdio.h>
#include <netinet/in.h>
#define MAXPATHLEN 8192
#define BUFFER_SIZE 8192

typedef struct _infostmp {
	char hostname[256];
	char ip[16];
	char url[8192];         /* FIXME! */
	char path[8192];        /* FIXME! */
	char filename[8192];    /* FIXME! */
	unsigned short int proto;
	unsigned short int ftp_mode;
	unsigned short int port;
	unsigned short int dataport;
	char user[256];
	char pass[256];
	unsigned long int size;
	char localfile_name[MAXPATHLEN];
	FILE* localfile_fp;
	struct sockaddr_in sockaddr;
	int sockfd;
	int sockfd_data;
	char buffer[BUFFER_SIZE];
	char isafolder;
	struct _infostmp *suiv;
} _infos;

_infos *liste_last();
_infos *liste_deb=NULL;
void *liste_clone_after(void *infos);


int main(){
char *liste=(char*)liste_clone_after((_infos*)NULL);
}

void *liste_clone_after(void *infos){
	void *ptr;
	void *suiv;
	ptr=(void*)malloc(sizeof(infos));
	if(ptr==NULL) return NULL;
	if(infos!=NULL){
		memcpy(ptr,infos,sizeof(_infos));
		((_infos*)ptr)->suiv=0;
		((_infos*)infos)->suiv=ptr;
	}
	else{ 		// si infos==NULL
		((_infos*)ptr)->suiv=NULL;
	}
	return ptr;

}



_infos *liste_last(){
	_infos *ptr=liste_deb;
	_infos *ptr_last=liste_deb;
	while(ptr!=NULL){
		ptr_last=ptr;
		ptr=ptr->suiv;
	}
	return ptr_last;
}

_infos *liste_prec(_infos *infos){
	_infos *ptr=liste_deb;
	_infos *ptr_last=liste_deb;

	while(ptr!=NULL){
		if(ptr==infos) return ptr_last;
		ptr_last=ptr;
		ptr=ptr->suiv;
	}
	return NULL;
}


void liste_del_all(_infos *deb){
	_infos *ptr=deb;
	_infos *suiv;
	while(ptr!=NULL){
		suiv=ptr->suiv;
		free(ptr);
		ptr=suiv;
	}
}


void liste_del(_infos *infos){
	_infos *ptr_prec;
	if(infos==NULL) return;
	ptr_prec=liste_prec(infos);

	if(infos==liste_deb){
		liste_deb=infos->suiv;
	}    

	ptr_prec->suiv=infos->suiv;
	free(infos);
}

int liste_count(_infos *deb){
	int i=0;
	_infos *ptr=deb;
	//_infos *suiv;
	while(ptr!=NULL){
		i++;
		ptr=ptr->suiv;
	}
	return i;
}

int affiche_infos(_infos *deb){
	int i=0;
	_infos *ptr=deb;
	//_infos *suiv;
	while(ptr!=NULL){
		i++;
		printf("%c ",ptr->isafolder);
		printf("path: %s - %s, taille %i\n",ptr->path,ptr->filename,ptr->size);
		ptr=ptr->suiv;
	}

	printf("\n");
	return i;
}

