#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

/* you many want to change the following information for your network */
#define TCP_PORT   6500
#define SERV_HOST_ADDR   "11.22.33.44"

main(int argc, char **argv)
{
	int	i, sockfd, ntimes = 1;
	struct sockaddr_in serv_addr;
	char buf[40];

	memset((char *) &serv_addr, 0, sizeof(serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = inet_addr(SERV_HOST_ADDR);
	serv_addr.sin_port = htons(TCP_PORT);

	if (argc == 2) ntimes = atoi(argv[2]);

	for (i=0; i < ntimes; i++) {
		if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
			perror("clientsoc: can't open stream socket"), exit(0);

		if (connect(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0)
			perror("clientsoc: can't connect to server"), exit(0);

		printf("sending segment %d\n", i);
		sprintf(buf, "DATA SEGMENT %d", i);
		write(sockfd, buf, strlen(buf));
		close(sockfd);
		}
	return(0);
}
